<?php
/*
This page uses a modified version of pctwo's scrip found on the SMF Community forums here:
http://www.simplemachines.org/community/index.php?topic=114026.0

Credit for the actual SMF insert goes to him, (though it's been heavily modified)
everything else (C) twistedsymphony 2007
*/

include_once('/www/virtual/affordableweb/www.zunemax.com/forum/SSI.php'); //requied in any SMF integration.
//verifies that the user is not currently set (would only occur if running in the SMF shell)
//if (!isset($context['user']) || !$context['user']['is_admin']) die ('Unknown error 744 has occurred');

require_once($sourcedir . '/Post.php'); //contains the functions to create new posts
require_once($sourcedir . '/Subs-Post.php'); //contains the sub functions to create new posts

//get the variables from the url
$board = $_GET['smf_board']; // The board the post will show up in
$ID_MEMBER = $_GET['smf_user']; //The user that will be credited with the post
$wp_id = $_GET['wp_id']; //The ID of the WP post we want to put into SMF
$ltxt = $_GET['ltxt']; //The text used to link back to WP

//this if statement checks that the necessary url variables exist, if not the script ends.
If (is_null($wp_id) || is_null($ID_MEMBER) || is_null($board)){
    exit ('ERROR: URL vars not set');
    }
    
/*This is a really really dirty hack where I grab the raw text from the WP config 
file and evaluate select lines out of it. I can't inlcude the file or it will 
conflict with SMF (do to an include statement at the end) but I need the database
variables So I grab the raw file data and only evaluate the select lines of code 
I'm interested in. If lines 3-6 and 9 aren't what I expect them to be... 
then this wont work at all */
$wp_config = file(dirname(__FILE__).'/../../../wp-config.php'); //loads wp-config.php into an array
eval ($wp_config[2]); //evaluates line 3 (define DB_NAME)
eval ($wp_config[3]); //evaluates line 4 (define DB_USER)
eval ($wp_config[4]); //evaluates line 5 (define DB_PASSWORD)
eval ($wp_config[5]); //evaluates line 6 (define DB_HOST)
eval ($wp_config[8]); //evaluates line 9 (set $table_prefix)

//this if statement makes sure I got the data I needed from the wp-config.php file, if not the script ends.
If (!defined('DB_NAME') || !defined('DB_USER') || !defined('DB_PASSWORD') || !defined('DB_HOST') || !isset($table_prefix)){
    exit ('ERROR: Cannot grab db values from wp-config.php');
    }

mysql_connect(DB_HOST, DB_USER, DB_PASSWORD);//setup my database server connection
mysql_select_db(DB_NAME); //select my database

//create a select statement that will grab the post title, content, and url.
//it joins with the meta table to grab a custom smf_id tag I use to relate WP posts with SMF topics
$wpsmfc_query = 'SELECT '.$table_prefix.'posts.post_title, '.$table_prefix.'posts.post_content, '.$table_prefix.'posts.guid, '.$table_prefix.'postmeta.meta_value';
$wpsmfc_query .= ' FROM '.$table_prefix.'posts';
$wpsmfc_query .= ' LEFT JOIN '.$table_prefix.'postmeta';
$wpsmfc_query .= ' ON '.$table_prefix.'posts.ID='.$table_prefix.'postmeta.post_id and '.$table_prefix.'postmeta.meta_key="smf_id"';
$wpsmfc_query .= ' WHERE '.$table_prefix.'posts.post_status="publish" and '.$table_prefix.'posts.ID='.$wp_id;
$wpsmfc_query .= ' LIMIT 1';

$resut_set = mysql_query($wpsmfc_query); //execute the query

//checks if we have a result set, if not the script ends
if(!$resut_set){ 
    exit("ERROR: Query Failed. Invalid Wordpress ID");
    }
//place the results into variables for use downstream
while($row = mysql_fetch_row($resut_set)) {
    $smf_title = $row[0];
    $smf_body = $row[1];
    $wp_plink = $row[2];
    $smf_topic = $row[3];
    }

//if the results inlcuded an SMF topic id then it already exists and there is no need to make a new topic.
If (!is_null($smf_topic)){
    redirectexit('topic=' . $smf_topic);	
    }
    
$smf_topic = 0;  //since there is no topic we set it to 0 to create a new topic in SMF.
$_POST['subject'] = $smf_title;  // the notify function requies this post data
$smf_title = addslashes($smf_title); //prep the subject for insertion
$smf_body = prepBody($smf_body,$ltxt,$wp_plink); //sends the body to the prep function below for SMF consumption

//creates an array of the post data for the post creation functions in SMF
$msgOptions = array(
		'id' => 0, // 0 means it's a new post in a topic, setting to a valid id would edit the post
		'subject' => $smf_title, //sets the message title to the above specified value
		'body' => $smf_body, //sets the message body to the above specified value
		'icon' => 'xx', // message icon (look at smf_message_icons table to see all possible values)
		'smileys_enabled' => 0,  //enables smilies (disabled to avoid WP conflicts)
		'attachments' => empty($attachIDs) ? array() : $attachIDs, //sets the attachments (not supported)
	);

//creates an array of the topic data for the post creation functions in SMF
$topicOptions = array(
		'id' => empty($smf_topic) ? 0 : $smf_topic, //sets the topic to the above specified value
		'board' => $board, //sets the board to the above specified value
		'poll' => null, //sets whether or not the topic is a poll (polls not suported)
		'lock_mode' => 0, //controlls whether or not the topic is locked on creation
		'sticky_mode' => null, //controlls whether or not the topic is sticky on creation
		'mark_as_read' => true, //set the topic as read by the creating user
	);
	
//creates an array of the user data for the post creation functions in SMF
$posterOptions = array(
		'id' => $ID_MEMBER, //the user id specified above
		'name' => 'ZuneMax', //the users name (can be anything)
		'email' => 'feedback@zunemax.com', //the users email (can be anything with an @ and .)
		'update_post_count' => 1 //determines whether or not this post adds to the users post count
	);

//determins if this is a new topic or just a new post in an existing topic
$newTopic = empty($smf_topic) || $smf_topic == 0;
	
//fires off SMF's create post funciton with the above arrays
createPost($msgOptions, $topicOptions, $posterOptions);

//gets the id of the newly created topic.
if (isset($topicOptions['id']))
		$smf_topic = $topicOptions['id'];
		
//sends off necessary notifications for subscribed users
if ($newTopic)
		notifyMembersBoard();
else
		sendNotifications($smf_topic, 'reply');
	
//create a new query to update the Wordpres meta table with the newly created SMF topic ID.
$wpsmfc_query = 'INSERT INTO '.$table_prefix.'postmeta (post_id, meta_key, meta_value) VALUES ('.$wp_id.', "smf_id", '.$smf_topic.')';
$resut_set = mysql_query($wpsmfc_query); //execute the query
	
//redirects the topic creator to the newly created post
redirectexit('topic=' . $smf_topic);

//modifies the body of the post for SMF 
function prepBody($txt,$ltxt,$rurl)
{
	//this ads [html] bb code tags so that SMF can consume the WP created html (only works for SMF admins)
  $txt = '[html]'.$txt.'[/html]';
  //adds a link back to the WP news page
  $txt .= '<br /><br />[url='.$rurl.']'.$ltxt.'[/url]';
  //preps for SMF's new post array
	return addslashes($txt);
} 
?>
