<?php
/*
Author: twistedsymphony
Author URI: http://solid-orange.com/
Description: Options for WP SMF Commenter
*/

//grabs the plugin data from the base plugin page for Commenter
load_plugin_textdomain('wpsmfc',$path = 'wp-content/plugins/wp_smf_commenter');

// Commenter's URI when viewed from the admin panel
$location = get_option('siteurl') . '/wp-admin/options-general.php?page=wp_smf_commenter/wp_smf_commenter_options.php';
    
//This creates the starting options if none exist
$wpsmfc_new=array(
    "wpsmfc_mid" => 1,
    "wpsmfc_bid" => 1,
    "wpsmfc_wptxt" => "Discuss this topic in our forums.",
    "wpsmfc_smtxt" => "View this topic on the news page.",
    "wpsmfc_url" => $location.'/fourms'
    );

add_option('wpsmfc', $wpsmfc_new); 
 
//grabs the form sumbit data and updates the options
if ('process' == $_POST['stage']){
    $wpsmfc=array(
        "wpsmfc_mid" => $_POST['wpsmfc_mid'],
        "wpsmfc_bid" => $_POST['wpsmfc_bid'],
        "wpsmfc_wptxt" => $_POST['wpsmfc_wptxt'],
        "wpsmfc_smtxt" => $_POST['wpsmfc_smtxt'],
        "wpsmfc_url" => $_POST['wpsmfc_url']
        );
    update_option('wpsmfc', $wpsmfc);
    }

//places the option in a useable variable for display back on the form
$wpsmfc = get_option('wpsmfc');


//the rest of this is the html form that makes up the Commenter options page... soo many options!
?><div class="wrap">
  <h2><?php _e('SMF Commenter Options', 'wpsmfc') ?></h2>
  <form name="form1" method="post" action="<?php echo $location ?>&amp;updated=true">
    <input type="hidden" name="stage" value="process" />
    <p><input name="wpsmfc_mid" type="text" id="wpsmfc_mid" value="<?php echo $wpsmfc['wpsmfc_mid']; ?>" size="5" />
    This is the Member ID of the SMF member you would like to appear as the one creating the WP posts in SMF (needs to be an admin for html support)</p>
    <p><input name="wpsmfc_bid" type="text" id="wpsmfc_bid" value="<?php echo $wpsmfc['wpsmfc_bid']; ?>" size="5" />
    This is the Board ID of the SMF board you would like the SMF topics to appear in.</p>
    <p><input name="wpsmfc_wptxt" type="text" id="wpsmfc_wptxt" value="<?php echo $wpsmfc['wpsmfc_wptxt']; ?>" size="40" />
    This is the text that will appear at the bottom of every WP post to link to SMF.</p>
    <p><input name="wpsmfc_smtxt" type="text" id="wpsmfc_smtxt" value="<?php echo $wpsmfc['wpsmfc_smtxt']; ?>" size="40" />
    This is the text that will appear at the bottom of every SMF topic to link back to WP.</p>
    <p><input name="wpsmfc_url" type="text" id="wpsmfc_url" value="<?php echo $wpsmfc['wpsmfc_url']; ?>" size="40" />
    This is the base URL of your SMF forum as it appears in the browser (exclude "/index.php" and everything after it).</p>
    <p class="submit">
        <input type="submit" name="Submit" value="<?php _e('Update Options', 'wpsmfc') ?> &raquo;" />
    </p>
  </form>
</div>
